unit AsciiUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids;

type
  TAsciiForm = class(TForm)
    AsciiGrid: TStringGrid;
    procedure AsciiGridSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure AsciiGridDblClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  AsciiForm: TAsciiForm;

implementation

uses CalcUnit;

{$R *.DFM}

var
  GCol,GRow : integer;
  
procedure TAsciiForm.AsciiGridSelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
begin
  GCol := ACol; GRow := ARow;
end;

procedure TAsciiForm.AsciiGridDblClick(Sender: TObject);
begin
  CalcForm.HexEdit.Text := IntToHex(((GCol-1) shl 4) + GRow - 1, 2);
  SourceFigure          := Hex;
  CalcForm.EquBtnClick(nil);
end;

procedure TAsciiForm.FormCreate(Sender: TObject);
var
  i,j   : integer;
begin
  with AsciiGrid do
  begin
    ColWidths[1] := 40;
    ColWidths[2] := 40;
    for i := 0 to 15 do
    begin
      Cells[0,i+1] := ' +' + IntToHex(i,1);
      Cells[i+1,0] := ' ' + IntToHex(i,1) + '0';
    end;
    for i := 0 to 1 do
      for j := 0 to 15 do
        Cells[i+1,j+1] := 'Ctrl - ' + chr((i shl 4) + j + 64);
    for i := 2 to 15 do
      for j := 0 to 15 do
        Cells[i+1,j+1] := '  ' + chr((i shl 4) + j);
  end;
end; // procedure TAsciiForm.FormCreate

end.
