unit ERUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, StdCtrls, ExtCtrls, Typedefs;

type
  TERDialog = class(TForm)
    Bevel1: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    Label3: TLabel;
    NameEdit: TEdit;
    ChipEdit: TEdit;
    OSEdit: TEdit;
    Label5: TLabel;
    DescMemo: TMemo;
    Label6: TLabel;
    Label7: TLabel;
    Label10: TLabel;
    Label9: TLabel;
    Label8: TLabel;
    MakeFileBtn: TButton;
    CloseBtn: TBitBtn;
    Label13: TLabel;
    TargetBoardEdit: TEdit;
    HelpBtn: TBitBtn;
    Label11: TLabel;
    USBYesNoCombo: TComboBox;
    Label12: TLabel;
    XtalEdit: TEdit;
    Label14: TLabel;
    procedure MakeFileBtnClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ERDialog: TERDialog;

const
  Col2 = 32;

implementation

uses Main, MiscUnit, CFGUnit, FileUnit;

{$R *.DFM}

procedure TERDialog.MakeFileBtnClick(Sender: TObject);
var
  EList            : tStringList;
  y,m,d,hr,min,s,v : word;
  i,j,k,h,EqualPos : integer;
  Buf,DBuf,DateBuf : string;
begin
  EList := tStringList.Create;
  DecodeDate(Now,y,m,d);
  DecodeTime(Now,hr,min,s,v);
  DateBuf := format('%4.4d',[y]) + '/' + format('%2.2d',[m]) + '/' + format('%2.2d',[d]) +
             ' at ' + format('%2.2d',[hr]) + ':' + format('%2.2d',[min]);
  DBuf := format('%4.4d',[y]) + format('%2.2d',[m]) + format('%2.2d',[d]) +
             '_' + format('%2.2d',[hr]) + format('%2.2d',[min]);
  try
    EList.Add('JBug11 Error Report ****************************************');
    EList.Add('');
    EList.Add('Name              = ' + NameEdit.Text);
    EList.Add('Chip type         = ' + ChipEdit.Text);
    EList.Add('OS                = ' + OSEdit.Text);
    EList.Add('Target board      = ' + TargetBoardEdit.Text);
    EList.Add('Crystal frequency = ' + XtalEdit.Text);
    EList.Add('Using USB adap    = ' + USBYesNoCombo.Text);
    EList.Add('Date/time         = ' + DateBuf);
    EList.Add('Version           = ' + VersionStr);
    EList.Add('');
    EList.Add('PROBLEM DESCRIPTION ****************************************');
    EList.AddStrings(DescMemo.Lines);
    EList.Add('');

    EList.Add('PROJECT FILE ***********************************************');
    j := EList.Count;
    WriteProjectCFGList(ProjData,EList);
    k := 1;                             // Find furthermost right equals sign
    for i := j to EList.Count - 1 do
    begin
      Buf      := EList[i];
      EqualPos := pos('=',Buf);
      if EqualPos > k then k := EqualPos;
    end;
    for i := j to EList.Count - 1 do    // Space all to same distance
    begin
      Buf      := EList[i];
      EqualPos := pos('=',Buf);
      if EqualPos > 1
      then begin
        delete(Buf,EqualPos,1);
        for h := EqualPos to k-1 do insert(' ',Buf,EqualPos);
        EList[i] := Buf;
      end;
    end;

    EList.Add('');
    EList.Add('OUTPUT WINDOW **********************************************');
    EList.AddStrings(MainForm.OWEdit.Lines);
    EList.Add('');
    EList.Add('COMMAND HISTORY WINDOW *************************************');
    EList.AddStrings(MainForm.CHEdit.Lines);

    Buf := ExtractFilePath(FN_ErrorReport) + 'ErrRpt_' + DBuf + '.txt';
    Buf := DeTokenizeFileName(Buf);
    if SaveDialogOK(Buf,ftErrRpt)
    then begin
      EList.SaveToFile(Buf);
      FN_ErrorReport := Buf;
    end;
  finally
    EList.Free;
  end; // try.. finally..
end; // procedure TERDialog.MakeFileBtnClick

procedure TERDialog.HelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(IDH_ERROR_REPORT);
end;

end.
