unit PauseUnit;

interface

uses Classes, SysUtils, Graphics, TypeDefs, Windows, Forms;

function PauseCheck(const CList   : tStringList;
                    var   Comment : tCmdLineComment;
                    var   Command : tCommand) : boolean;
procedure Pause;

implementation

uses CmdUnit, CheckUnit, MiscUnit, Main;

var PauseTime : longword;

function PauseCheck(const CList   : tStringList;
                    var   Comment : tCmdLineComment;
                    var   Command : tCommand) : boolean;
var
  ArgType  : tArgType;
  Val      : longword;
begin
  Result  := false;
  Comment := clcArgErr;

  if Prog.MacroState <> msPlaying
  then begin
    Comment := clcOnlyInMacros;
    exit;
  end;

  if not NumArgsOK(CList,1,1,Comment) then exit;
  if not StateIsAllowed([psStopped,psRun],Comment) then exit;

  if FoundArgOK(CList,1,[atInteger],ArgType,Val)
  then begin
    if Val > 100000
    then begin
      Comment := clcArgOutOfRange; exit;
    end;
    PauseTime := Val;
  end
  else exit;

  Result    := true;                // Arguments are OK
  Comment   := clcOK;
end; // function PauseCheck

procedure Pause;
var
  EndTime : DWord;
begin
  if PauseTime <= 0 then exit;
  EndTime := GetTickCount + PauseTime;
  while (GetTickCount < EndTime)
        and
        (Prog.MacroState = msPlaying)
        and not PauseEndSignalled
    do begin
      if Application.Terminated then exit;
      Application.ProcessMessages;
    end;
  if PauseEndSignalled then MainForm.OWEdit.Lines.Add('Pause end signalled');
  PauseEndSignalled := false;
end; // procedure Pause

end.

