type
  tCmdLineComment =
  (clcOK,
   clcBlank,
   clcCmdErr,

{psDuffData,psDisconnected,psConnected,psStopped,psRun,psTrace,psRunStop,psTraceStop,psUser}
   clcProjectError,
   clcNotWhenDisconnected,
   clcNotWhenConnected,
   clcNotWhenStopped,
   clcNotInRun,
   clcNotInTrace,
   clcNotAtBP,

   clcAlreadyDisconnected,
   clcAlreadyConnected,

//   clcNoRemoteSwitch,
   clcNoSwitch,
   clcSwitchAlreadyOn,
   clcSwitchAlreadyOff,

{maNone,maRam,maCtrlRegs,maRom,maEeprom,maEprom,maExtRam,maExtFlash,maUnimplemented}
   clcUndefinedMem,
   clcNoWriteRam,
   clcNoWriteCtrlRegs,
   clcNoWriteRom,
   clcNoWriteEeprom,
   clcNoWriteEprom,
   clcNoWriteExtRam,
   clcNoWriteByteWrite,
   clcNoWritePageWrite,

   clcSpanNotAllowed,
   clcNoCompOverlap,
   clcToFollowFIND,
   clcFoundFailed,
   clcRegNotFound,

   clcArgOutOfRange,
   clcNoRemoteReset,
   clcBadS19Format,
   clcNoChangePC,

   clcEepromOverlayError,
   clcEpromOverlayError,
   clcByteOverlayError,
   clcPageOverlayError,
   clcIndRegsOverlayError,
   clcIndMemOverlayError,

   clcPTCONset,
   clcNotEepromTalker,
   clcNoEepromDefined,
   clcBPROTDisallowsErase,
   clcBPROTMayDisallowWrite,

   clcDuplicateBP,
   clcBPNotFound,

   clcArgErr,
   clcTooFewArgs,
   clcTooManyArgs,
   clcAddrRangeErr,
   clcStringTooShortLong,

   clcNotinMacros,
   clcOnlyInMacros,
   clcBeginNotFound,
   clcNoLibraryMacros,

   clcFileNotFound,
   clcUnrecognizedFileType,
   clcFileTooLarge,

   clcInvalidStartCode,
   clcInvalidStartSWI,

   clcNotImplemented,
   clcLast);

const
  CommentArray : array[tCmdLineComment] of string =
   ('',
    '',
    'Unrecognized command',

    'Project error - command not available',
    'Not available when disconnected',
    'Requires talker initialization',
    'Not available when Stopped',
    'Not available when running',
    'Not available when tracing',
    'Not available when stopped at breakpoint',

    'Already disconnected',
    'Already connected',
    'Switch not available',
    'Switch is already ON',
    'Switch is already OFF',

    'Address(es) overlap undefined memory',
    'Address(es) overlap RAM',
    'Address(es) overlap Control Registers',
    'Address(es) overlap ROM',
    'Address(es) overlap EEPROM',
    'Address(es) overlap EPROM/OTP ROM',
    'Address(es) overlap external RAM',
    'Address(es) overlap byte-written memory',
    'Address(es) overlap page-written memory',

    'Address span not allowed',
    'Comparison address ranges overlap',
    'Must follow FIND or NEXT',
    'Previous FIND failed',
    'Register not found',

    'Argument out of range',
    'Remote reset not available',
    'Formatting error in S19 file',
    'Cannot change PC',

    'Eeprom overlay error',
    'Eprom overlay error',
    'Byte-writing overlay error',
    'Page-writing overlay error',
    'Indirect register overlay error',
    'Indirect memory overlay error',

    'PTCON is set in BPROT',
    'Talker in EEPROM cannot write EE/Eprom',
    'No EEPROM memory is defined',
    'BPROT value disallows erasing',
    'BPROT value may disallow writing',

    'Duplicate breakpoint(s) not allowed',
    'Breakpoint(s) not found',

    'Argument(s) not recognized',
    'Too few arguments',
    'Too many arguments',
    'Address range error',
    'String too short/long',

    'Command not available in macros',
    'Command only available in macros',
    'BEGIN not found',
    'No library macros found',

    'File not found',
    'Unrecognized file type',
    'Binary file is too large',

    'Invalid opcode at start address',
    'Invalid SWI at start address',

    'Command not implemented',
    '');

type
  tCommand = (
    cmdNone,
    cmdAddBR,
    cmdAddBRP,
    cmdAlterConfig,
    cmdBulkEraseEeprom,
    cmdByteEraseEeprom,
    cmdClearBreak,
    cmdClearOutputWindow,
    cmdClearLocal,
    cmdCompare,
    cmdCompareLocal,
    cmdConnect,
    cmdCRCMCUbyFile,
    cmdCRCFileLocal,
    cmdCRC,
    cmdCRCLocal,
    cmdDisconnect,
    cmdDuplicate,
    cmdDuplicateLocal,
    cmdEnd,
    cmdFill,
    cmdFillLocal,
    cmdFind,
    cmdFindLocal,
    cmdGo,
    cmdList,
    cmdListLocal,
    cmdListIndirect,
    cmdListMacro,
    cmdLoadS19MCU,
    cmdLoadS19Local,
    cmdLoadS19Indirect,
    cmdLoadBinMCU,
    cmdLoadBinLocal,
    cmdLoadBinIndirect,
    cmdSwitchOff,
    cmdSwitchOn,
    cmdModify,
    cmdModifying,
    cmdNoBR,
    cmdOpenTerminal,
    cmdPause,
    cmdPlayMacro,
    cmdReset,
    cmdRegInherentDisplay,
    cmdRegInherentChange,
    cmdRegSingleDisplay,
    cmdRegSingleChange,
    cmdRegDoubleDisplay,
    cmdRegDoubleChange,
    cmdRegIndirectDisplay,
    cmdRegIndirectChange,
    cmdRPC,
    cmdSaveMCUToS19,
    cmdSaveLocalToS19,
    cmdSaveIndirectToS19,
    cmdSaveMCUToBin,
    cmdSaveLocalToBin,
    cmdSaveIndirectToBin,
    cmdSetBreak,
    cmdStepOver,
    cmdStop,
    cmdTrace,
    cmdUnassemble,
    cmdUnassembleLocal,
    cmdVerifyS19Local,
    cmdVerifyS19MCU,
    cmdVerifyErase);

{Variables associated with command in progress}
var
  LastCommand  : tCommand;

   