{Registry information --------------------------------------------------------}
const
  RegRoot            = '\Software\BeattSoft\JBug11\';
  GeneralKey         = 'General';
  LayoutKey          = 'Layout';

var
  WorkRoot,UserRoot,ReadInRoot,ThisVersion : string;

const
  VN_OWFontSize       = 'OW font size';
  VN_OWWordWrap       = 'OW word wrap';
  VN_CHFontSize       = 'CH font size';
  VN_BoldColor        = 'Color for bold items';
  VN_MainLeft         = 'Main form left';
  VN_MainTop          = 'Main form top';
  VN_MainWidth        = 'Main form width';
  VN_MainHeight       = 'Main form height';
  VN_CHEditHeight     = 'CH edit height';
  VN_SidebarWidth     = 'Sidebar width';
  VN_BPPanelHeight    = 'BP panel height';
  VN_MacroLeft        = 'Macro edit left';
  VN_MacroTop         = 'Macro edit top';
  VN_MacroWidth       = 'Macro edit width';
  VN_MacroHeight      = 'Macro edit height';
  VN_MacroKOT         = 'Macro edit keep on top';
  VN_MEFontSize       = 'Macro edit font size';
  VN_ShowMEForm       = 'Show macro editor';
  VN_SymbolLeft       = 'Symbol table left';
  VN_SymbolTop        = 'Symbol table top';
  VN_SymbolHeight     = 'Symbol table height';
  VN_SymbolKOT        = 'Symbol table keep on top';
  VN_ShowSymbolForm   = 'Show symbol table';
  VN_SymbolsShowing   = 'Form displays Symbols';
  VN_SortByAddress    = 'Sort symbols by address';
  VN_ConverterLeft    = 'Converter left';
  VN_ConverterTop     = 'Converter top';
  VN_ConverterKOT     = 'Converter keep on top';
  VN_ShowCalcForm     = 'Show converter';
  VN_AsciiLeft        = 'ASCII left';
  VN_AsciiTop         = 'ASCII top';
  VN_MemMapLeft       = 'Memory map left';
  VN_MemMapTop        = 'Memory map Top';
  VN_MemMapHeight     = 'Memory map height';
  VN_MemMapKOT        = 'Memory map keep on top';
  VN_ShowMapForm      = 'Show memory map';
  VN_TermWordWrap     = 'Wrap text in TW';
  VN_TWTop            = 'Terminal form top';
  VN_TWLeft           = 'Terminal form left';
  VN_TWHeight         = 'Terminal form height';
  VN_TWWidth          = 'Terminal form width';
  VN_TWOnTop          = 'Terminal form stay on top';
  VN_AsciiWidth       = 'Ascii window width';
  VN_TWFontSize       = 'Terminal form font size';
  VN_IMTabVisible     = 'IM tab visible';

type
  tLayoutRec = record
    MainLeft,
    MainTop,
    MainWidth,
    MainHeight,
    CHEditHeight,
    SidebarWidth,
    BPPanelHeight,
    MacroLeft,
    MacroTop,
    MacroWidth,
    MacroHeight,
    SymbolLeft,
    SymbolTop,
    SymbolHeight,
    ConverterLeft,
    ConverterTop,
    AddToWatchLeft,
    AddToWatchTop    : integer;
  end;

const
  Layout6x4 : tLayoutRec =
   (MainLeft       : 0;
    MainTop        : 0;
    MainWidth      : 593;
    MainHeight     : 449;
    CHEditHeight   : 96;
    SidebarWidth   : 181;
    BPPanelHeight  : 60;
    MacroLeft      : 30;
    MacroTop       : 30;
    MacroWidth     : 200;
    MacroHeight    : 200;
    SymbolLeft     : 60;
    SymbolTop      : 60;
    SymbolHeight   : 300;
    ConverterLeft  : 120;
    ConverterTop   : 120;
    AddToWatchLeft : 150;
    AddToWatchTop  : 150);

  Layout8x6 : tLayoutRec =
   (MainLeft       : 0;
    MainTop        : 0;
    MainWidth      : 713;
    MainHeight     : 549;
    CHEditHeight   : 96;
    SidebarWidth   : 181;
    BPPanelHeight  : 70;
    MacroLeft      : 30;
    MacroTop       : 30;
    MacroWidth     : 200;
    MacroHeight    : 200;
    SymbolLeft     : 60;
    SymbolTop      : 60;
    SymbolHeight   : 300;
    ConverterLeft  : 120;
    ConverterTop   : 120;
    AddToWatchLeft : 150;
    AddToWatchTop  : 150);

  Layout10x7 : tLayoutRec =
   (MainLeft       : 0;
    MainTop        : 0;
    MainWidth      : 773;
    MainHeight     : 649;
    CHEditHeight   : 96;
    SidebarWidth   : 181;
    BPPanelHeight  : 80;
    MacroLeft      : 300;
    MacroTop       : 100;
    MacroWidth     : 400;
    MacroHeight    : 400;
    SymbolLeft     : 774;
    SymbolTop      : 0;
    SymbolHeight   : 300;
    ConverterLeft  : 760;
    ConverterTop   : 540;
    AddToWatchLeft : 150;
    AddToWatchTop  : 150);

const
  OWFontSize : integer = 8;
  CHFontSize : integer = 10;
  MEFontSize : integer = 10;

var
  BoldColor  : tColor = clBlack;

