type
  tMemArea       = (maUndefined,maRam,maCtrlRegs,maRom,maEeprom,maEprom,
                    maExtRam,maByteWrite,maPageWrite,maIndRegs,maIndMem);
  tMemAreaSet    = set of tMemArea;
  tMemAreaArray  = array[tMemArea] of tMemArea;
  tMemTypeArray  = array[0..$FFFF] of tMemArea;

{tMemRecord is used when building a map of bytes in memory}
  tMemRecord     = record
                     Area  : tMemArea;
                     SA,EA : word;
                     Desc  : string
                   end;
  tMemRecordPtr  = ^tMemRecord;
  tMemAreas      = array of tMemRecord;

  tMemArray      = array[0..$FFFF] of byte;
  tMemType       = (mtNone,mtIntrinsic,mtIndirect);

var
  MemMap,IndMemMap : tList;
  Memory,IndMemory : tMemArray;
  MemTypeArray     : tMemTypeArray;

const
  MemoryVNArray : array[tMemArea] of string = (
    'Undefined',
    'RAM',
    'Control Regs.',
    'Mask ROM',
    'EEPROM',
    'EPROM/OTP ROM',
    'External RAM',
    'Ext Byte Write',
    'Ext Page Write',      // 14 characters
    'Ind. Registers',
    'Ind. Memory'
  );

  MemoryDescArray : array[tMemArea] of string = (
    'undefined memory',
    'RAM',
    'Control Registers',
    'mask ROM',
    'EEPROM',
    'EPROM / OTP-ROM',
    'external RAM',
    'external byte-written memory',
    'external page-written memory',
    'indirect memory registers',
    'indirect memory'
  );

  CtrlByteArray : array[tMemArea] of byte = (
    $00,
    $41,
    $41,
    $00,
    $02,
    $20,
    $41,
    $42,
    $22,
    $30,
    $30
       );

