{Assembler information.  Array of mnemonics, mnemonic type, and associated
 opcodes}
type
  tAddrMode = (amNone,amINH,amIMM,amDIR,amEXT,amIX,amIY,amREL,amDirective);
  tInstructionType = (itNone,itIllegalOpcode,itSimple,itBranch,itBSR,itJSR,
                      itJump,itJumpIX,itJumpIY,itRTI,itRTS,itSWI);

const
  AddrModeArray : array[tAddrMode] of Str5 =
   ('','INH','IMM','DIR','EXT','IND,X','IND,Y','REL','');

type
  tOperandType = (otNone,otII,otJJ,otKK,otHH,otLL,otDD,otMM,otFF,otRR);

const
  OperandTypeArray : array[tOperandType] of Str2 =
   ('','ii','jj','kk','hh','ll','dd','mm','ff','rr');

{Opcode look-up information ------------------------------------------------- }
type
  tOpcodeDatumPtr = ^tOpcodeDatum;
  tOpcodeDatum = record
                   Mnemonic  : Str5;       // Opcode mnemonic
                   Desc      : string;     // Description
                   Operation : string;     // Symbolic description of operation
                   AddrMode  : tAddrMode;  // Addressing mode
                   Opcode1,Opcode2            : byte;         // Opcode(s)
                   Opd1Type,Opd2Type,Opd3Type : tOperandType; // Operands
                   Cycles    : byte; // Machine cycles for this operation
                   PCOffset  : byte; // Program counter offset after execution
                  end;
{To save space and at the same time to make look-up reasonably fast, the
 information associated with each opcode is stored as a record on the heap,
 pointed to by two arrays of pointers.  The array index is the opcode byte
 whose information is required.  }
  tOpcodeData = array[0..255] of tOpcodeDatumPtr;
var
  OpcodePage1,OpcodePage2,OpcodePage3,OpcodePage4 : tOpcodeData;

{Break point information -----------------------------------------------------}
type
  tBPType   = (bpNone,bpStart,bpTemp,bpTransient,bpFixed,bpPass);
  tBPRecord = record
                Addr,SeqAddr,AltAddr : word;
                NextAddr             : word;
                MemVal,Offset        : byte;
                OWStr,BPStr          : string;
                Inst                 : Str5;
                InstType             : tInstructionType;
                BPType               : tBPType;
                IsNextTraceBP        : boolean;
                ActingAsTempBP       : boolean;
                Trigger,PassCount    : integer;
                IsSet                : boolean;
                OrderAdded           : integer;
                OpcodeDatumPtr       : tOpcodeDatumPtr;
                Opd1,Opd2,Opd3       : byte;
              end;
  tBPRecordPtr = ^tBPRecord;
  tSetOfBPTypes = set of tBPType;

  tBPSortOrder = (soType,soAddress,soOrderAdded);

var
  BPList : tList;
  BPSortOrder : tBPSortOrder = soOrderAdded;

